/**
 * Modulo: ahorcado.c
 *
 * Descripcion: programa para jugar al juego "Ahorcado" (1 jugador).
 *
 * Autor: Ivan Cantador, ivan.cantador@uam.es
 *
 * Version: 1.0
 * Fecha: 16/10/2017
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

// ================================
// Definicion de valores constantes
// ================================

#define MAX_FALLOS 6
#define TAM_VOCABULARIO 8
#define MAX_CADENA 32

// =======================
// Definicion de funciones
// =======================

int aleatorio(int a, int b) {
	return (int) (a + (double) rand() / (RAND_MAX-1) * (b - a + 1));
}

// =================
// Funcion principal
// =================

int main() {
	const char *VOCABULARO[TAM_VOCABULARIO] = {"vehiculo", "edificio", "camiseta", "boligrafo", "murcielago", "dromedario", "melocoton", "mermelada"};
	char palabra[MAX_CADENA], palabraUsuario[MAX_CADENA], respuesta[MAX_CADENA];
	char letra, letras[28];
	int i, n, fallos, encontrada;

	// Inicializamos el generador de numeros aleatorios
	srand((unsigned) time(NULL));
	
	// Elegimos la palabra a adivinar
	i = aleatorio(0, TAM_VOCABULARIO-1);
	strcpy(palabra, VOCABULARO[i]);
	
	// Inicializamos la palabra del usuario
	for ( i = 0; i < strlen(palabra); i++ ) {
		palabraUsuario[i] = '_';
	}
	palabraUsuario[i] = '\0';

	// Jugamos...
	fallos = 0;			// sin fallos
	letras[0] = '\0';	// sin letras introducidas
	
	while ( fallos < MAX_FALLOS ) {
		// Pedimos al usuario una letra
		printf("\nTus letras introducidas son: %s", letras);
		printf("\nTus letras encontradas son: %s\n", palabraUsuario);
		
		printf("\nPalabra de %d letras. %d fallos de %d. Introduce una letra: ", strlen(palabra), fallos, MAX_FALLOS);
		scanf("\n%c", &letra);
		
		// Guardamos la letra en la lista de letras introducidas
		n = strlen(letras);
		for ( i = 0 ; i < n ; i++ ) {
			if ( letras[i] == letra ) {
				break;
			}
		}
		if ( i == n ) {
			letras[n] = letra;
			letras[n+1] = '\0';			
		}
		
		// Buscamos la letra en la palabra
		encontrada = 0;
		for ( i = 0 ; i < strlen(palabra) ; i++ ) {
			if ( palabra[i] == letra ) {
				palabraUsuario[i] = letra;
				encontrada = 1;
			}
		}
		if ( encontrada == 0 ) {
			fallos++;
		}
				
		// Preguntamos al usuario por la palabra
		printf("\nTus letras introducidas son: %s", letras);
		printf("\nTus letras encontradas son: %s\n", palabraUsuario);

		printf("Cual es la palabra a adivinar? ");
		scanf("%s", respuesta);
		
		// Comprobamos si el usuario ha adivinado la palabra
		if ( strcmp(palabra, respuesta) == 0 ) {
			break;
		}		
	}

	if ( fallos < MAX_FALLOS ) {
		printf("\nEnhorabuena, has acertado la palabra!!\n");		
	}
	else {
		printf("\nAhorcado!! Lo siento; has perdido. La palabra era: %s\n", palabra);		
	}	
	
	return 0;
}
